<template>
  <div class="chartBox">
    <div class="ChartBox">
      <JwChat-index :taleList="list" @enter="bindEnter" v-model="inputMsg" :toolConfig="tool">
      </JwChat-index>
    </div>
  </div>
  <!--  -->
</template>

<script>
import msgData from "../../assets/js/msg/msgData";
import store from "../../store";
import bus from "./../../assets/js/bus.js";
import { getAIMessage, getV1Fastgpt } from "../../api/api.js";
import mapInfo from "../../assets/js/map/mapInfo.js";
import axios from "axios";
export default {
  name: "jwChat",

  data() {
    return {
      inputMsg: "",
      loading: false,
      list: [],
      msgData: [],
      tool: {
        show: ["file", "history", "img"],
        callback: this.toolEvent
      },
      config: {
        img: "/image/cover.png",
        name: "JwChat",
        dept: "最简单、最便捷",
        callback: this.bindCover
      }
    };
  },
  computed: {
    Obj() {
      return store.state.setMsgData;
    }
  },
  watch: {
    Obj(newVal, oldVal) {
      if (newVal) {
        if (newVal.text == "加载完成") {
          setTimeout(() => {
            this.setMsgImg();
          }, 500);
          setTimeout(() => {
            this.setMsgtab();
          }, 1500);
          this.loading = false;
          store.state.setMsgData = null;
        } else {
          this.list[this.list.length - 1].text = newVal;
        }
      }
    }
  },
  mounted() {
    if (window.timer) {
      clearInterval(window.timer);
      window.timer = null;
    }
    // this.setLoading();
    setTimeout(() => {
      this.setMsgStart("您好");
    }, config.loadTime);
    bus.$on("mapInfo", (res) => {
      if (res) {
        this.setMapInfo(res);
      }
    });
    bus.$on("setInsertMarkDown", (res) => {
      if (res) {
        this.setMarkDownInfo(res);
      }
    });
    // axios.get("http://192.168.11.89:12315/Markdown.md").then((response) => {
    //     if (response.status == 200) {
    //       console.log(response);
    //       this.setMarkDownInfo(response.data);
    //     }
    //   });
  },
  methods: {
    bindEnter() {
      const msg = this.inputMsg;
      if (!msg) return;
      this.getMsg("role", msg);
      this.setLoading();
      setTimeout(() => {
        this.setMsgStart(msg);
      }, 200);
    },
    async setMsgStart(res) {

      if (res == "三维实景") {
        this.setV1Fastgpt(res)
      } else {
        const data = await getAIMessage(res);
        if (data.status == 200) {
          if (data.content) {
            this.getMsg("ai", data.content);
          } else {
            this.getMsg("ai", "");
          }
          if (data.name) {
            this.$store.state.setScreenFlag = true;
            this.$nextTick(() => {
              setTimeout(() => {
                mapInfo.init(data.name);
              }, 1000);
            });
          }
        }
      }
    },
    async setV1Fastgpt(res) {
      const data = await getV1Fastgpt(res);
      const obj = data.split(/[\n]/)
      const list_a = [];
      obj.filter(item => {
        if (item.indexOf("data: ") > -1) {
          if (item.indexOf('nodeId') > -1) {
          } else  if(item.indexOf("content")>-1){
            const a = JSON.parse(item.split('data: '))
            console.log(a);
            // if (a.choices[0].content) {
            //   console.log(a.choices[0].content);
            // }



          }

        }
      })
      // console.log(list_a)
      // const a = val_data[0].split('data: ');
      // const b = JSON.parse(a[1]);
      // console.log(b)
      // const c = b[1].historyPreview.length - 1;
      // const d = b[1].historyPreview[c].value
      // this.getMsg("ai", d);
    },
    setMarkDownInfo(res) {

      var roleMsg = msgData.getRole("markDown", res);
      this.list.push(roleMsg.msg);
      // 
    },
    setMapInfo(res) {
      var msg = "";
      if (res.type === "erroInfo") {
        msg = "<div>异常查询</div>" + res.value;
      }
      this.getMsg("role", msg);
      this.setMsgStart(res.value);
    },
    getMsg(type, msg) {
      var roleMsg = msgData.getRole(type, msg);
      if (this.loading) {
        this.loading = false;
        const length = this.list.length - 1;
        this.list[length].text = roleMsg.msg.text;
      } else {
        this.list.push(roleMsg.msg);
      }
    },
    setShowMsg() {
      if (this.msgData.text) {
        this.setMsgText();
      } else if (this.msgData.img) {
        this.setMsgImg();
      }
    },
    setMsgText() {
      if (this.msgData.text) {
        msgData.setmsgText(this.msgData.text);
      }
    },
    setMsgImg() {
      if (this.msgData.img) {
        var val = msgData.setmsgImg(this.msgData.img);

        this.list.push(val);
      }
    },
    setMsgtab() {
      if (this.msgData.tab) {
        var val = msgData.setmsgtab(this.msgData.tab);

        this.list.push(val);
      }
    },
    setLoading() {
      const loader = msgData.getLoader();
      this.list.push(loader);
      this.loading = true;
    },
    getLoadingFlag() {
      if (this.list.length == 0) {
        return;
      }
      var load = this.list[this.list.length - 1].text;
      if ((load.indexOf = "loading" > -1)) {
        return true;
      }
      return false;
    }
  }
};
</script>
<style scoped>
/* .rightSlot {
    width: 100%;
    height: 100%;
    overflow: hidden;
    flex-direction: column;
} */
.chartBox {
  width: 100%;
  height: 100vh;
  background: black;
  position: relataive;
}
</style>
<style scoped>
.divboder {
  display: flex;
}

.tabTable {
  width: 100%;
  min-width: 25vh !important;
  text-align: center;
  border: 1px solid #c1c1c1;
}

.tabTable .tabHeader {
  height: 32px;
  background: linear-gradient(180deg, #28a9de 0%, #1987c2 100%);
  border-radius: 0px 0px 0px 0px;
  color: white;
}

.tabTable .tabBody tr {
  height: 64px;
  border-bottom: 1px solid #c1c1c1;
}

.tabTable .tabBody td:nth-child(2) {
  height: 64px;
  word-break: break-all;
  word-wrap: break-word;
  text-align: center;
  width: 68%;
  padding: 0px 1%;
  line-height: 30px;
  border-bottom: 1px solid #c1c1c1;
}

@keyframes siz {
  from {
    width: 0;
  }

  to {
    width: 100%;
  }
}

.msgText {
  width: 300px;
  word-break: break-all;
  word-wrap: break-word;
  overflow: hidden;
  white-space: normal;
  letter-spacing: 0.15em;
  animation: siz 3s steps(60) forwards;
}

.loading {
  margin: 20px;
  position: relative;
  width: 1px;
  height: 1px;
}

.loading:before,
.loading:after {
  position: absolute;
  display: inline-block;
  width: 15px;
  height: 15px;
  content: "";
  border-radius: 100%;
  background-color: #000;
}

.loading:before {
  left: -15px;
  animation: ball-pulse infinite 0.75s -0.4s cubic-bezier(0.2, 0.68, 0.18, 1.08);
}

.loading:after {
  right: -15px;
  animation: ball-pulse infinite 0.75s cubic-bezier(0.2, 0.68, 0.18, 1.08);
}

@keyframes ball-pulse {
  0% {
    transform: scale(1);
    opacity: 1;
  }

  50% {
    transform: scale(0.1);
    opacity: 0.6;
  }

  100% {
    transform: scale(1);
    opacity: 1;
  }
}
</style>
